--
--
--
screenFades = class:new()
--This class is the base class for all graphical objects.
--
--
--For the sake of simplicity
--This engine only supports 20 depth levels
screenFades.fadeTime = 1000 
screenFades.fadeSize = 40
screenFades.waitTime = 30
screenFades.timeToClose = 15
screenFades.toDo = ""
screenFades.spawner = ""
screenFades.toLevel = ""

function screenFades:startFade(action, a,b,c)
  self.fadeTime = 0
  changePause = true
  if action == "mapChange" then
     self.toDo = action
     self.spawner = b
     self.toLevel = a
   end
end


function screenFades:update(dt)
   
   self.fadeTime = self.fadeTime +1
end



function screenFades:draw()
   if self.fadeTime<self.timeToClose then
      for i=0,(1280/self.fadeSize)  do 
         for p=0,(720/self.fadeSize)  do
            love.graphics.setColor( 0, 0, 0, math.clamp(0, (self.fadeTime/self.timeToClose)*300, 255) )
            --love.graphics.rectangle("fill", 25 - (self.fadeTime/2) + (i*50)+cam.x-1280/2, 25 -  (self.fadeTime/2) + (p*50)+cam.y-720/2, self.fadeTime, self.fadeTime)
            love.graphics.rectangle("fill", (self.fadeSize/2) - (self.fadeTime/ (self.timeToClose/self.fadeSize*2) ) + (i*self.fadeSize)+cam.x-1280/2, (self.fadeSize/2) -  (self.fadeTime/ (self.timeToClose/self.fadeSize*2) ) + (p*self.fadeSize)+cam.y-720/2, (self.fadeTime/self.timeToClose)*self.fadeSize, (self.fadeTime/self.timeToClose)*self.fadeSize)
   
         end
      end   
   elseif self.fadeTime<self.waitTime then
         love.graphics.setColor( 0, 0, 0,255,255 )
         love.graphics.rectangle("fill", cam.x-1280/2, cam.y-720/2, 1280, 720)
         
         if self.fadeTime == self.timeToClose then
            if self.toDo == "mapChange" then
               changeMap(self.toLevel,self.spawner)
            end
         end
         
         
   elseif self.fadeTime<self.waitTime+self.timeToClose then
      changePause = false
      for i=0,(1280/self.fadeSize)  do 
         for p=0,(720/self.fadeSize)  do
            love.graphics.setColor( 0,0, 0,math.clamp(0, 255-((self.fadeTime-90)*5), 255)) 
            
            love.graphics.setColor( 0, 0, 0, math.clamp(0, 255 - (((self.fadeTime-self.waitTime)/self.timeToClose)*300), 255) )
            love.graphics.rectangle("fill", (self.fadeSize/2) - (self.fadeSize-((self.fadeTime-self.waitTime)/ (self.timeToClose/self.fadeSize*2) )) + (i*self.fadeSize)+cam.x-1280/2, (self.fadeSize/2) -  (self.fadeSize - ((self.fadeTime-self.waitTime)/ (self.timeToClose/self.fadeSize*2) )) + (p*self.fadeSize)+cam.y-720/2, self.fadeSize-((self.fadeTime-self.waitTime)/self.timeToClose)*self.fadeSize, self.fadeSize-((self.fadeTime-self.waitTime)/self.timeToClose)*self.fadeSize)
   
   
            --love.graphics.rectangle("fill",  25 - ((50-(self.fadeTime-90))/2) +  (i*50)+cam.x-1280/2,  25 - ((50-(self.fadeTime-90))/2) +  (p*50)+cam.y-720/2, 50-(self.fadeTime-90), 50-(self.fadeTime-90))
         end
      end
   else
      
   end
end
 