function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

mapNormals = {}
camFollowDistX = 50

function startGame()
   p1= player:new()
   p1.name = "p1"
   addSprite(p1.name, p1)
   p1.x = 400
   p1.y = 700
gameState = 'game'
   changeMap('garden4', 'top')
   
   
end


function generateNormals(layer, norms)
   
   for i = 1, tablelength(layer.data) do
      for p = 1, tablelength(layer.data[0]) do
        table.insert(mapNormals, lightWorld:newRectangle( (i-1)*25, (p-1)*25, 25, 25):setNormalMap(norms, (i-1)*25, (p-1)*25))
      end
   end
end



pLayers = {}

function handleParallax()
   for nam, obj in pairs(pLayers) do        
      obj.x = obj.truX + ((cam.x - (curMap.width*tileSize/2))/obj.properties.parallax)
      obj.y = obj.truY + ((cam.y - (curMap.height*tileSize/2))/obj.properties.parallax)
   end   
end



function changeMap(newMap, spawnPosition)
   curMap = mapList[newMap]
   particleList = {}
	waterLocal = {}
   pLayers = nil
   pLayers = {}
 
   for nam, obj in pairs(curMap.layers) do
      if obj.properties.parallax then
         pLayers[obj.name] = nil
         if not obj.truX then
           obj.truX = obj.x
           obj.truY = obj.y
        end
         pLayers[obj.name] = obj
         
      end
   end   

    for nam, obj in pairs(curMap.layers.spawnPositions.objects) do
      if obj.name == spawnPosition then
            p1=nil
            deleteSprite("p1")
            p1= player:new()
            p1.name = "p1"
            addSprite(p1.name, p1)
            p1.x = obj.x-p1.oX
            p1.y = obj.y-p1.oY
            break
      end
   end   
   
   
   for k1, v1 in pairs(curMap.layers.CD.data) do
      
      for k2, v2 in pairs(v1) do
         if type(v2) == 'table' then
            if v2.gid == 2 then
              -- lightWorld:newRectangle(k2*25, k1*25, 25, 25):setShadow(true)
            end
         end
      end
   end

   for nam, obj in pairs(curMap.layers.camBound.objects) do
       cam = gamera.new(math.rd(obj.x), math.rd(obj.y), math.rd(obj.width), math.rd(obj.height))
     
       break
   end   
   cam.x = p1.x
   cam.y = p1.y
	

	if curMap.layers.spawnGrass ~= nil then 
		
		
		
		for nam, obj in pairs( curMap.layers.spawnGrass.data) do
			for nam1, obj1 in pairs(obj) do
				if type(obj1) == 'table' then
					local i = 0
					if obj1.gid == 8 then
						local vinMin = ((nam1-1)*tileSize)
						local vinMax = ((nam1-1)*tileSize)
						local tempVineTile = 8
						while tempVineTile == 8 do
							vinMin = vinMin - 3
							tempVineTile = getSTile(vinMin, ((nam-1)*tileSize))
						end
						tempVineTile = 8
						while tempVineTile == 8 do
							vinMax = vinMax + 3
							tempVineTile = getSTile(vinMax, ((nam-1)*tileSize))
						end
					
						--while i<3 do
							if(math.random()<.7) then
							addParticle('greenVine',
								math.random(vinMin,vinMax),
								((nam-1)*tileSize),
								0,
								0,
								0,
								0,
								0,
								function(part) 
									if(not part.init) then
										part.ends = love.math.random(vinMin,vinMax)
										part.y2 = part.y
										while cWithLevel(part.x,part.y) do
											part.y =part.y + 100
										end
										while cWithLevel(part.ends,part.y2) do
											part.y2 =part.y2 + 100
										end
										while not cWithLevel(part.x,part.y) do
											part.y =part.y - 1
										end
										while not cWithLevel(part.ends,part.y2) do
											part.y2 =part.y2 - 1
										end
										part.rando = math.random();
										part.width = math.random()*3
										local randomHeight = math.random(360)
										part.curve = love.math.newBezierCurve( part.x,part.y,part.x+((part.ends-part.x)/2),((part.y+part.y2)/2)+randomHeight ,part.ends,part.y2)

										part.e = part.curve:render(4)
										part.e1 = part.curve:render(4)
										part.e2 = part.curve:render(4)
										part.leaves = {}
										part.droop = {}
										part.ropes = {}
										local tempLeafX = nil
										local tempLeafY = nil
										local curLef = 0
										while curLef<1 do									
	
											tempLeafX,tempLeafY  = part.curve:evaluate(curLef)
											table.insert(part.leaves,1,{tempLeafX,tempLeafY,.5+(math.random()*1.2),math.random()*6})
											curLef = curLef + .02+(math.random()/15)
										end
										curLef = 0
										while curLef<1 do									
	
											tempLeafX,tempLeafY  = part.curve:evaluate(curLef)
											table.insert(part.droop,1,{tempLeafX,tempLeafY,math.random(50)+25})
											curLef = curLef + .3+(math.random()/5)
										end
										curLef = 0
										if math.random()<.3 then
										while curLef<1 do									
	
											tempLeafX,tempLeafY  = part.curve:evaluate(curLef)
											table.insert(part.ropes,1,{tempLeafX,tempLeafY,curLef})
											curLef = curLef +.007
										end
										end
										part.init = true
									end 
								
							end)
						end
--								i = i + 1
						--end
					
					end
					--Grass
					
					
					
					if obj1.gid == 7 then									
						
						while i<tileSize do
							
								
										
							addParticle('greenGrass',
								((nam1-1)*tileSize)+i,
								((nam-1)*tileSize),
								0,
								0,
								0,
								0,
								0,
								function(part) 
									if(not part.init) then
										part.wind = -2+(math.random()*4)
										part.initWind = part.wind
										part.windDir = 'left'
										part.init = true;
										part.heightMod = (math.random()*12)+2
										part.standMod = 0;
										part.pHits = false;
										part.widths = math.random();
										part.xMod = (math.random()*4)-2
										part.randWindElement = 0
										part.drawn = false;
										while not cWithLevel(part.x,part.y-1) do
											part.y =part.y + 1
										end
										

										part.bez = love.math.newBezierCurve( part.x+(-2.5),part.y,part.x+(part.initWind*5),part.y-5 ,part.x+part.initWind+part.xMod,part.y -part.heightMod+part.standMod)
										part.bez2 = love.math.newBezierCurve( part.x+(2.5),part.y,part.x+(part.initWind*5),part.y+5 , part.x-part.initWind+part.xMod,part.y -part.heightMod+part.standMod)
										
										part.e = joinMyTables(part.bez:render(4), part.bez2:render(4))
							part.e1 = part.bez:render(4)
							part.e2 =  part.bez2:render(4)
									end 
									if part.wind<part.initWind-.2 then
										part.wind = part.wind +.1
									elseif part.wind>part.initWind+.2 then
										part.wind = part.wind -.1
									end
									
								--	part.randWindElement = part.randWindElement + ((math.random(9)/10)-.5)
									if p1.x+p1.oX>part.x-8 and p1.x+p1.oX<part.x+8 and p1.y+p1.oY>part.y-7 and p1.y+p1.oY<part.y+7  then
										if not part.pHits then
											part.pHits = true
											if p1.xSpeed >0 then
												part.wind=part.initWind*10
											else
												part.wind=part.initWind*10
											end
											part.standMod = 3
											if part.standMod > part.heightMod then
												part.standMod = part.heightMod
												
											end
										end
									else
										if part.standMod>0 then
											part.standMod = part.standMod - .5
										end
											
										part.pHits = false
									end
									
									if part.wind>2 then
										part.windDir = 'right'
									end
									if part.wind<-2 then
										part.windDir = 'left'
									end
									
								end)
								i = i + 3
						end
					end
				end
			end
		end  
	
	
     
   end  
	

	  
	
	for nam, spr in pairs(spriteList) do
         if string.match( spr.name, "water") or string.match( spr.name, "playerBullet") then
				deleteSprite(spr.name)
       end
   end
		
		
		
	for nam, obj in pairs(curMap.layers.water.objects) do
		waterLocal["water"..obj.x] = waterSim:new()
		
		waterLocal["water"..obj.x].name = "water"..obj.x
		waterLocal["water"..obj.x].depth = 1
		waterLocal["water"..obj.x]:inits(obj.x,obj.y,obj.width,obj.height)
		addSprite(waterLocal["water"..obj.x].name, waterLocal["water"..obj.x])
  
   end   
	curMap.layers.water.visible = false
	
   

   print(newMap, spawnPosition)

end

function changeCTile(tx,ty,newTile) 
   tx = math.floor(tx/tileSize) + 1
   ty = math.floor(ty/tileSize) + 1
   local tile = 0
   
    
   if curMap.layers.CD.data[ty] ~= nil then 
      if curMap.layers.CD.data[ty][tx] then 
           
         
         local s =   curMap.tileInstances[curMap.layers.CD.data[ty][tx].gid]
         for i,v in ipairs(s) do            
            if v.x == (tx-1)*32 and v.y == (ty-1)*32 then
               v.batch:set(v.id, 0, 0, 0, 0, 0)
               curMap.layers.CD.data[ty][tx] = false
            end
         end
            
         for p,l in ipairs(curMap.layers) do   
            if string.match(l.name,"dest") then
					if l.data[ty][tx] then
						s = curMap.tileInstances[l.data[ty][tx].gid]
						for i,v in ipairs(s) do            
							if v.x == (tx-1)*32 and v.y == (ty-1)*32 then
								v.batch:set(v.id, 0, 0, 0, 0, 0)
							end
						end
					end
            end
         end
         
         
      end
   end  
end

function getCTile(tx,ty) 
   tx = math.floor(tx/tileSize) + 1
   ty = math.floor(ty/tileSize) + 1
   local tile = 0
   if curMap.layers.CD.data[ty] ~= nil then 
      if curMap.layers.CD.data[ty][tx] then 
            tile = curMap.layers.CD.data[ty][tx].gid
      end
   end  
   return tile
end

function getSTile(tx,ty) 
   tx = math.floor(tx/tileSize) + 1
   ty = math.floor(ty/tileSize) + 1
   local tile = 0
   if curMap.layers.spawnGrass.data[ty] ~= nil then 
      if curMap.layers.spawnGrass.data[ty][tx] then 
            tile = curMap.layers.spawnGrass.data[ty][tx].gid
      end
   end  
   return tile
end
function cWithLevel(tx,ty)
   local tile = getCTile(tx,ty)
   local col = false
   tx = tx%tileSize
   ty = ty%tileSize

   if tile == 2 then col = true
      
   --Regular slopes
   --
   elseif tile == 3  then col = tx<ty 
   elseif tile == 4  then col = tx>-(ty-tileSize) 
   elseif tile == 5  then col = tx>ty 
   elseif tile == 6  then col = tx<-(ty-tileSize) 
   --Half Slopes
   --
   elseif tile == 9  then col = (tx/2)<ty
   elseif tile == 10 then col = (tx/2)+(tileSize/2)<ty
   elseif tile == 11 then col = (tx/2)>-(ty-tileSize)
   elseif tile == 12 then col = (tx/2)+(tileSize/2)>-(ty-tileSize)
   --Quarter Slopes
   --
   elseif tile == 17 then col = (tx/4)<ty
   elseif tile == 18 then col = (tx/4)+(tileSize/4)<ty
   elseif tile == 19 then col = (tx/4)+((tileSize*2)/4)<ty
   elseif tile == 20 then col = (tx/4)+((tileSize*3)/4)<ty

   elseif tile == 21 then col = (tx/4)>-(ty-tileSize)
   elseif tile == 22 then col = (tx/4)+((tileSize)/4)>-(ty-tileSize)
   elseif tile == 23 then col = (tx/4)+((tileSize*2)/4)>-(ty-tileSize)
   elseif tile == 24 then col = (tx/4)+((tileSize*3)/4)>-(ty-tileSize)
   
   elseif tile == 25 then col = true
   elseif tile == 26 then col = true
   elseif tile == 27 then col = true
   elseif tile == 28 then col = true

   elseif tile == 29 then col = true
elseif tile == 30 then col = true
   
     elseif tile == 31 then col = true
   elseif tile == 32 then col = true
   end


    
   return col
end


function cWithLevelNoSlope(tx,ty)
   local tile = getCTile(tx,ty)
   local col = false
   tx = tx%tileSize
   ty = ty%tileSize

   if tile == 2 then col = true
      elseif tile == 5  then col = tx>ty 
   elseif tile == 6  then col = tx<-(ty-tileSize) 
   end


    
   return col
end

function getCSlope(tx,ty)
   local tile = getCTile(tx,ty)
   local col = math.atan2(0,0)


   if tile == 2 then col = math.atan2(0,0)
      
   --Regular slopes
   --
   elseif tile == 3  then col = 0
   elseif tile == 4  then col =0
   elseif tile == 5  then col =0
   elseif tile == 6  then col = 0
   --Half Slopes
   --
   elseif tile == 9  then col = 0
   elseif tile == 10 then col = 0
   elseif tile == 11 then col = 0
   elseif tile == 12 then col =0
   --Quarter Slopes
   --
   elseif tile == 17 then col = 0
   elseif tile == 18 then col = 0
   elseif tile == 19 then col = 0
   elseif tile == 20 then col =0

   elseif tile == 21 then col = 0
   elseif tile == 22 then col = 0
   elseif tile == 23 then col = 0
   elseif tile == 24 then col = 0
   
   elseif tile == 25 then col = math.atan2(-2,1)
   elseif tile == 26 then col = math.atan2(-2,1)
   
   elseif tile == 27 then col = 0
   elseif tile == 28 then col = 0

   elseif tile == 29 then col = 0
elseif tile == 30 then col = 0
      elseif tile == 31 then col = 0
   elseif tile == 32 then col = 0
   end

   return col
end

function getSkiSlope(tx,ty)
   local tile = getCTile(tx,ty)
   local col = math.atan2(0,0)


   if tile == 2 then col = math.atan2(0,0)
      
   --Regular slopes
   --
   elseif tile == 3  then col = math.atan2(3,3) 
   elseif tile == 4  then col = math.atan2(-3,3) 
   elseif tile == 5  then col = -math.atan2(3,3)
   elseif tile == 6  then col = -math.atan2(-3,3)
   --Half Slopes
   --
   elseif tile == 9  then col = math.atan2(1.5,3)
   elseif tile == 10 then col = math.atan2(1.5,3)
   elseif tile == 11 then col = math.atan2(-1.5,3)
   elseif tile == 12 then col = math.atan2(-1.5,3)
   --Quarter Slopes
   --
   elseif tile == 17 then col = math.atan2(.75,3)
   elseif tile == 18 then col = math.atan2(.75,3)
   elseif tile == 19 then col = math.atan2(.75,3)
   elseif tile == 20 then col = math.atan2(.75,3)

   elseif tile == 21 then col = math.atan2(-.75,3)
   elseif tile == 22 then col = math.atan2(-.75,3)
   elseif tile == 23 then col = math.atan2(-.75,3)
   elseif tile == 24 then col = math.atan2(-.75,3)
   
   elseif tile == 25 then col = math.atan2(3,3)
   elseif tile == 26 then col = math.atan2(-3,3)
   
   
   elseif tile == 27 then col = math.atan2(1.5,3)
   elseif tile == 28 then col = math.atan2(.75,3)

   elseif tile == 29 then col = math.atan2(-.75,3)
   elseif tile == 30 then col = math.atan2(-1.5,3)
   
   elseif tile == 31  then col = -math.atan2(3,3)
   elseif tile == 32  then col = -math.atan2(-3,3)
   end

   return col
end

function transByRad( x, y, cx, cy, ox, oy, rad )
    local nx = (x - cx)*math.cos( rad ) - (y - cy)*math.sin( rad ) + ox
    local ny = (x - cx)*math.sin( rad ) + (y - cy)*math.cos( rad ) + oy

    return nx, ny;
end



function joinMyTables(t1, t2)
 
   for k,v in ipairs(t2) do
      table.insert(t1, v)
   end 
 
   return t1
end



function angleDiff(angle1,angle2)
   return (angle1-angle2+math.pi)%(2*math.pi) - math.pi
end

function table.shallow_copy(t)
  local t2 = {}
  for k,v in pairs(t) do
    t2[k] = v
  end
  return t2
end