--
--
--
pBullet  = sprite:new()
--This class is the base class for all graphical objects.
--
--
pBullet.graphic = players.defaultBullet
pBullet.xSpeed = 10;
pBullet.ySpeed = 0;

pBullet.oX = 15
pBullet.oY = 6

pBullet.anis = lightWorld:newAnimationGrid(pBullet.graphic,100,100)
--player.anis:setNormalMap(players.tempNormal)
pBullet.g = pBullet.anis:newGrid(15, 12)


pBullet.anis:addAnimation('main',pBullet.g('1-4',1), 0.0334)
pBullet.hasAni = true
pBullet.currentAni = "main"
pBullet.anis:setAnimation(pBullet.currentAni)
pBullet.anis.ix = 0
pBullet.stopTime = 0;
pBullet.anis.iy = 0
pBullet.destroyGround = false

function pBullet:update(dt)
 if not changePause then
      self.x = self.x + self.xSpeed
      self.y = self.y + self.ySpeed
    
      
		if self.ySpeed < 0 then
				--self.rot = -math.pi/2;
				--self.faceLeft = false
		end
      if cWithLevel(self.x+self.oX,self.y+self.oY) then
         self.xSpeed = 0
         self.ySpeed = 0
         if self.destroyGround == true then
				changeCTile(self.x+self.oX,self.y+self.oY, 0)
			end
			
			deleteSprite(self.name)
			
      end
		
	--[[	addParticle('gunSpawn',
									self.x + 3,
									self.y + 3,
									6-(math.random()*12),
									-2+(math.random()*3),
									1,
									1,
									0,
									 function(part) 
										if(not part.init) then
											part.scaleX = .8+math.random()
											part.init = true
										end 
										part.xSpeed = part.xSpeed * .98 
										part.ySpeed = part.ySpeed * .98 
										part.scaleX = part.scaleX * .98
										if cWithLevel(part.x,part.y)  or part.scaleX < .05 then
											part.remove = true
										end 
									end)
      --]]
     
      self.anis:setAnimation(self.currentAni)
  else
    self.anis.animations[self.currentAni]:pause()
  end
end