--
--
--
player = sprite:new()
--This class is the base class for all graphical objects.
--
--

player.graphic = players.temp
player.xSpeed = 0;
player.ySpeed = 0;
player.gSpeed = 0;
player.gAcc = .51
player.runSpeed = 5;
player.magSpeed = 2;
player.oX = 34
player.oY = 112
player.lBound = -17
player.rBound = 17
player.uBound = -105
player.inAir = false
player.running = false;
player.touchingWall = false;
player.slp = 0;
player.rollingTime = 100
player.offsetX = 0
player.offsetY = 0
player.aimUp = false;
player.puckControl = false;

player.jumpFrames = 0;
player.jumpFramesMax = 10;
player.jumpChange = .6;
player.jumpInit = -7;
player.justJump = false;
player.tRot = 0;

player.magnet = false
player.justMag = false;
player.magnetDir = 'd'

player.puckOut = false;
player.isRolling = false;
player.gunX = 20
player.gunY = 38-112
player.gunSpawnX = 0
player.gunSpawnY = 0
player.gunModX = 1
player.gunModY = 1
player.bulletInc = 0;
player.lastShot = 0;
player.lastWaterSim = nil;
player.puckHold = 0;


player.aimUpGunSpawn = {-30,-50}
--
--
--
--


--player.anis = lightWorld:newAnimationGrid(player.graphic,100,100)
--player.anis:setNormalMap(players.tempNormal)
--player.g = player.anis:newGrid(70, 112)


--player.anis:addAnimation('stand',player.g('1-1',1), 0.0167)
--player.anis:addAnimation('standShot',player.g(2,1), 0.0167)
--player.anis:addAnimation('standShotUp',player.g(3,1), 0.0167)
--player.anis:addAnimation('run',  player.g(25,1,17,2), .4)
--player.anis:addAnimation('runShot',player.g(4,1), 0.0167)
--player.anis:addAnimation('runShotUp',player.g(5,1), 0.0167)
--player.anis:addAnimation('air1', player.g(18,3), 0.0167)
--player.anis:addAnimation('air2', player.g(25,3), 0.0167)
--player.anis:addAnimation('air3', player.g(6,4), 0.0167)
--player.anis:addAnimation('wall', player.g(14,4), 0.0167)
--player.anis:addAnimation('wallBack', player.g(1,5), 0.0167)
player.hasAni = 'Spriter'
--player.currentAni = "stand"
--player.anis:setAnimation(player.currentAni)
--player.anis.ix = 0
--player.anis.iy = 0

player.wallStuck = false;
player.wallStuckLeft = false
player.wallLookingBack = false
player.inWater = false;

player.canMagnet = false; 

player.jPressed = false;

--SET ANIMATIONS
--player.animations["run"] = anim8.newAnimation(player.g('10-25',1,'1-17',2), 0.04)
--player.animations["stand"] = anim8.newAnimation(player.g('1-1',1), 0.04)
--player.animations["air1"] = anim8.newAnimation(player.g(18,3), 0.04)
--player.animations["air2"] = anim8.newAnimation(player.g(25,3), 0.04)
--player.animations["air3"] = anim8.newAnimation(player.g(6,4), 0.04)

--
--
--


player.spriterData = Spriter:loadSpriter( "sprites", 'protag' )
player.spriterData:setCurrentAnimationName('Stand')
player.spriterData:setScale(.175,.175);
player.spriterData:setOffset(0,0);
player.spriterData:setCanvasOffset(0,-100)
player.spriterData:setOffset(-50,-30 )


player.invOff = 168
player.rotOffX = 85
player.rotOffY = 125


player.spriterData:setInversionOffset(player.invOff)

function player:handleCamera(sp)
   
    self.spriterData:update( 1/60)
   
     for nam, obj in pairs(sp) do
         if obj.properties.doNotFollow then
            if obj.x+(obj.width) > self.x+self.oX and  obj.x< self.x+self.oX then
               if obj.y+(obj.height) > self.y+self.oY and  obj.y < self.y+self.oY then     
                  camToX =cam.x+((-cam.x+(obj.x+(obj.width/2)))/15)
                  camToY = cam.y+((-cam.y+(obj.y+(obj.height/2)))/15) 
                  return
               end
            end
         elseif obj.properties.lockX then
            if obj.x+(obj.width) > self.x+self.oX and  obj.x< self.x+self.oX then
               if obj.y+(obj.height) > self.y+self.oY and  obj.y < self.y+self.oY then
						local centerDist = cam.x-self.x-self.oX
						if math.abs(centerDist)> camFollowDistX+100  then
							centerDist = math.clamp(-camFollowDistX ,centerDist,camFollowDistX )
							camToX = math.floor(cam.x+((-cam.x+self.x+self.oX+centerDist)/30))
							camToY = math.floor(cam.y+((-cam.y+(obj.y+(obj.height/2)))/30))
						end
                  if camToX-640 < obj.x then
                       camToX = math.floor(cam.x+(-cam.x+obj.x+640)/30)  
                  end
                  return
               end
            end
         elseif obj.properties.lockY then
            if obj.x+(obj.width) > self.x+self.oX and  obj.x< self.x+self.oX then
               if obj.y+(obj.height) > self.y+self.oY and  obj.y < self.y+self.oY then   
                  camToX = math.floor(cam.x+((-cam.x+(obj.x+(obj.width/2)))/5))
                  camToY = math.floor(cam.y+((-cam.y+self.y+self.oY)/5)) 
                 
                  return
               end
            end
         end
      end   
      for nam, obj in pairs(curMap.layers.camBound.objects) do
         cam:setWorld(math.rd(obj.x), math.rd(obj.y), math.rd(obj.width), math.rd(obj.height))
         break
      end   
      camToX = math.floor(cam.x+((-cam.x+self.x+self.oX)/5))
      camToY = math.floor(cam.y+((-cam.y+self.y+self.oY)/5)) 

end
--
function player:handleMapChanges(sp)
     for nam, obj in pairs(sp) do
         if obj.x+(obj.width) > self.x+self.oX and  obj.x< self.x+self.oX then
            if obj.y+(obj.height) > self.y+self.oY and  obj.y < self.y+self.oY then    
               faders:startFade("mapChange", obj.properties.toMap, obj.properties.spawner)
               return
            end
         end
      end   
end
--
function player:handleHiddenAreas(sp)
     for nam, obj in pairs(sp) do
        curMap.layers['hidden-'..obj.name].opacity = 1
         if obj.x+(obj.width) > self.x+self.oX and  obj.x< self.x+self.oX then
            if obj.y+(obj.height) > self.y+self.oY and  obj.y < self.y+self.oY then    
               curMap.layers['hidden-'..obj.name].opacity = 0
               return
            end
         end
      end   
end
--
function player:handleMagnet(sp)
   self.canMagnet = false

   if sp == nil then return end
  for nam, obj in pairs(sp) do
		if obj.x+(obj.width) > self.x+self.oX and  obj.x< self.x+self.oX then
			if obj.y+(obj.height) > self.y+self.oY and  obj.y < self.y+self.oY then    
				self.canMagnet = true
				return
			end
		end
	end   
end
--

function player:handleWater(sp)
	local lastWater  = self.inWater;
	self.inWater = false;
   if sp == nil then return end
	for nam, obj in pairs(sp) do
		if obj.x+(obj.width) > self.x+self.oX and  obj.x< self.x+self.oX then
			if obj.y+(obj.height) > self.y+self.oY-50 and  obj.y < self.y+self.oY-50 then   
				self.lastWaterIn = spriteList["water"..obj.x];
				self.inWater = true
				break;
			end
		end
	end   
	if self.inWater ~= lastWater then
		if self.inWater then
			self.lastWaterIn:disturb(self.x+self.oX, 12)
		else
			self.lastWaterIn:disturb(self.x+self.oX, -12)
		end			
	end
end
--
function player:groundLogic(dt)
   
  
   if input:down("right") and self.rollingTime>25 then
      self.faceLeft = false;
      self.gSpeed = self.gSpeed + self.gAcc
      self.running = true
      if self.gSpeed<0 then
         self.gSpeed = self.gSpeed + self.gAcc
      end
      if self.magnet then
         self.gSpeed = self.magSpeed
      end
      
   elseif input:down("left") and self.rollingTime>25 then
		
		
      self.faceLeft = true;
      self.gSpeed = self.gSpeed - self.gAcc
      self.running = true
      if self.gSpeed>0 then
         self.gSpeed = self.gSpeed - self.gAcc
      end
       if self.magnet then
         self.gSpeed = -self.magSpeed
      end
   else 
      if self.gSpeed<0 then
         self.gSpeed = self.gSpeed + self.gAcc/1.2
      end
      if self.gSpeed>0 then
         self.gSpeed = self.gSpeed - self.gAcc/1.2
      end
      self.slp = 0
      if self.magnet then
         self.gSpeed = 0
      end
   end



   if input:pressed ("magnet") and not self.magnet  and self.rollingTime>25 and self.canMagnet then
      self.magnet = true
      self.justMag = true
      self.magnetDir = 'd'
      self.y = self.y +8
   end

   
   if self.magnet then
      
   end
   
   self.gSpeed = limitNum(self.gSpeed, self.runSpeed)
   
   if self.magnet then
      self.xSpeed = 0
      self.ySpeed = 0
      -- player is attached to walls. 
      if self.magnetDir == 'd' then
         self.xSpeed = self.gSpeed
      elseif self.magnetDir == 'u'  then
         self.xSpeed = -self.gSpeed
      elseif self.magnetDir == 'l'  then
         self.ySpeed = self.gSpeed
      elseif self.magnetDir == 'r'  then
         self.ySpeed = -self.gSpeed
      end
      
      
   else       
      
      
      if self.gSpeed>0 then
         self.xSpeed = self.gSpeed*math.cos(getCSlope(self.x+self.oX,self.y+self.oY+3));
         self.ySpeed = -self.gSpeed*math.sin(getCSlope(self.x+self.oX,self.y+self.oY+3));      
      else    
         self.xSpeed = self.gSpeed*math.cos(getCSlope(self.x+self.oX,self.y+self.oY+3));
         self.ySpeed = self.gSpeed*math.sin(getCSlope(self.x+self.oX,self.y+self.oY+3));   
      end
      
      
   end

   if input:pressed('jump') and self.magnet == false then
      self.justJump = true;
      self.ySpeed = self.jumpInit
      self.inAir = true
      self.y = self.y-5
      self.jumpFrames = 0;
   end
end
--
function player:airLogic(dt)
   
   
      --Give character slight control of self in the air
   if input:down("right")  then
      if self.xSpeed<self.runSpeed then
         self.xSpeed = self.xSpeed + (self.gAcc/2)
      end
   elseif input:down("left") then
      if self.xSpeed>-self.runSpeed then
         self.xSpeed = self.xSpeed - (self.gAcc/2)
      end
   else
   end

   if input:down('jump') and self.jumpFrames<self.jumpFramesMax then
      self.ySpeed = self.ySpeed - self.jumpChange
   else
      self.jumpFrames = 1000
   end
   self.ySpeed = self.ySpeed + gravity
   self.jumpFrames = self.jumpFrames + 1
end
--
function  player:wallJumping(dt)
   self.wallLookingBack = false
   if self.inAir then
      if not input:down("down")  then
         if cWithLevel(self.x+self.oX+self.lBound-5, self.y+self.oY-51) and love.keyboard.isDown("left") then
            self.wallStuck = true
            self.wallStuckLeft = true
            self.faceLeft = true;
         elseif cWithLevel(self.x+self.oX+self.rBound+5, self.y+self.oY-51) and love.keyboard.isDown("right") then
            self.wallStuck = true
            self.faceLeft = false;
            self.wallStuckLeft = false
         end
      end
      if self.wallStuck then
         if self.ySpeed>2 then self.ySpeed = 2 end
            if( input:down("down") ) then
               self.wallStuck = false
            end
         if self.wallStuckLeft then
            if input:down("right")  then
               self.wallLookingBack = true
            end
            if input:pressed('jump') and not self.justJump  then
               self.xSpeed = 6.5
               self.x = self.x +4
               self.ySpeed = -9
               self.jumpFrames = 6
               self.wallStuck = false
               self.faceLeft = false;
            end  
         end  
         if not self.wallStuckLeft then
            if input:down("left")  then
               self.wallLookingBack = true
            end
            if input:pressed('jump') and not self.justJump then
               self.x = self.x -4
               self.xSpeed = -6.5
               self.ySpeed = -9
               self.jumpFrames = 6
               self.wallStuck = false
               self.faceLeft = true;
            end
         end  
         if not cWithLevel(self.x+self.oX+self.lBound-6, self.y+self.oY-51) and not cWithLevel(self.x+self.oX+self.rBound+6, self.y+self.oY-51) then
            self.wallStuck = false
         end
      end
   else
      self.wallStuck = false
   end
end
--
function player:rolling(dt)
   self.rollingTime = self.rollingTime + 1
   if input:pressed("roll") and not self.inAir and self.rollingTime>40 and not self.magnet then
      self.rollingTime = 0;
       self.ySpeed = 0
      self.y = self.y-3
      if self.faceLeft then
         self.xSpeed = -10
      else
         self.xSpeed = 10
      end
   end
    if self.rollingTime<23 then
      if self.faceLeft then
         self.gSpeed = -4
         self.xSpeed = -4
      else
         self.gSpeed = 4
         self.xSpeed = 4
      end
   end
    if self.rollingTime<13 then
      if self.faceLeft then
         self.gSpeed = -8
         self.xSpeed = -8
      else
         self.gSpeed = 8
         self.xSpeed = 8
      end
   end
    if self.rollingTime<2 then
      if self.faceLeft then
         self.gSpeed = -4
         self.xSpeed = -4
      else
         self.gSpeed = 4
         self.xSpeed = 4
      end
   end

  
end


--Logic for magnets
--very complex so seperated to it's own module
require('pLogic.magnet')

function player:recallPuck(teleport)
	if teleport then	
		self.x = singlePuck.x
		self.y = singlePuck.y - 120

	end
	singlePuck = nil
	deleteSprite("sPuck")
	self.puckOut = false
	self.magnet = false;
	self.tRot = 0 
end
function player:walls(dt)
   while cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-10) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-28) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-51) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-73) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound, self.y+self.oY-85) do
      self.gSpeed = 0 
      self.xSpeed = 0
      self.x = self.x+1
      self.touchingWall = true
   end
   
   while cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-10) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-28) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-51) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-73) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound, self.y+self.oY-85) do
      self.gSpeed = 0 
      self.xSpeed = 0
      self.x = self.x-1
      self.touchingWall = true
   end
   
   
   
   
   if cWithLevelNoSlope(self.x+self.oX+self.lBound-2, self.y+self.oY-10) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound-2, self.y+self.oY-28) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound-2, self.y+self.oY-51) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound-2, self.y+self.oY-73) or
            cWithLevelNoSlope(self.x+self.oX+self.lBound-2, self.y+self.oY-85) and self.faceLeft then
      self.touchingWall = true
      self.xSpeed = 0 
   end
   
   if (cWithLevelNoSlope(self.x+self.oX+self.rBound+2, self.y+self.oY-10) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound+2, self.y+self.oY-28) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound+2, self.y+self.oY-51) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound+2, self.y+self.oY-73) or
            cWithLevelNoSlope(self.x+self.oX+self.rBound+2, self.y+self.oY-85) )  and not self.faceLeft then
      self.touchingWall = true
      self.xSpeed = 0 
   end
   
   while cWithLevel(self.x+self.oX+10, self.y+self.oY+self.uBound) or
         cWithLevel(self.x+self.oX-10, self.y+self.oY+self.uBound) do
      if self.ySpeed<0 then
          self.ySpeed = 0
      end
      self.jumpFrames = 1000
     
      self.y = self.y+1
         
   end
end
--
function player:update(dt)
   
      if not changePause then
         self.justJump = false;
         self.touchingWall = false
         
        
         if math.abs(self.xSpeed) <.1 then
            self.xSpeed = 0
         end
         if math.abs(self.ySpeed) <.1 then
            self.ySpeed = 0
         end
         
         self.running = false
         
         -- actions for not being in the air!
         if not self.inAir then
            self:groundLogic(dt)
         end
         
         
         
         ---THis is what to do when the character is in the air.
         if self.inAir then
            self:airLogic(dt)
         end
           
         if self.wallStuck then
            self.xSpeed = 0;
         end
         
         self:rolling(dt);
         self.x = math.rd(self.x + math.rd(self.xSpeed))
         self.y = math.rd(self.y + math.rd(self.ySpeed))

         
         if self.ySpeed > maxFall then
            self.ySpeed = maxFall
         end
         self.aimUp = false
         if input:down('up')then 
            self.aimUp = true
         end
         if not self.magnet then
            while (cWithLevel(self.x+self.oX-11,self.y+self.oY) or  cWithLevel(self.x+self.oX+11,self.y+self.oY) ) and self.ySpeed>=0 do
               self.ySpeed = 0
               self.y = self.y-1
            end
            
            if  (cWithLevel(self.x+self.oX-11,self.y+self.oY+7) or cWithLevel(self.x+self.oX+11,self.y+self.oY+7)) and self.ySpeed>=0  then
               if self.inAir then self.gSpeed = self.xSpeed end
               self.inAir = false
               while not cWithLevel(self.x+self.oX-13,self.y+self.oY) and not cWithLevel(self.x+self.oX+13,self.y+self.oY)  do
                  self.y = self.y+1
               end
            else
               self.inAir = true
            end 
         end   
         
         if not self.magnet then
            self:wallJumping(dt)
            self:walls();
         else
            self:magnets();
            self.inAir = false;
            self.justMag = false;
         end
			
      
         
         if self.faceLeft then
				self.gunX = -42
				self.gunY = 43-112
				if self.aimUp then
					self.gunX = self.gunX - self.aimUpGunSpawn[1]
					self.gunY = self.gunY + self.aimUpGunSpawn[2]
				end
         else
				self.gunX = 42
				self.gunY = 43-112
				if self.aimUp then
					self.gunX = self.gunX + self.aimUpGunSpawn[1]
					self.gunY = self.gunY + self.aimUpGunSpawn[2]
				end
         end
         self.gunSpawnX = self.gunSpawnX 
         self.gunSpawnY = self.gunSpawnY 
         
         
          
         local gunSpeedX = 0
			local gunSpeedY = 0
			self.lastShot = self.lastShot - 1;
         if input:pressed('shoot') and not self.isRolling then
			
            if self.faceLeft then
               if self.aimUp then
                  self.gunModX, self.gunModY = transByRad(-12,0,0,0,0,0,self.rot+(.5*math.pi))
               else
                  self.gunModX, self.gunModY = transByRad(-12,0,0,0,0,0,self.rot)
               end
            else
               if self.aimUp then
                  self.gunModX, self.gunModY = transByRad(12,0,0,0,0,0,self.rot-(.5*math.pi))
               else
                  self.gunModX, self.gunModY = transByRad(12,0,0,0,0,0,self.rot)
               end
            end
            
				local tempBullet = pBullet:new()
				tempBullet.name = "playerBullet" .. self.bulletInc
				tempBullet.x = p1.x + self.gunSpawnX - tempBullet.oX
				tempBullet.y = p1.y + self.gunSpawnY - tempBullet.oY
        
        
				
				tempBullet.xSpeed = self.gunModX*1.2
				tempBullet.ySpeed = self.gunModY 
				if self.magnet then
					tempBullet.rot = self.rot
					if self.aimUp then
						tempBullet.rot = tempBullet.rot-math.pi/2;
					end
				else
					if self.aimUp then
						tempBullet.rot = -math.pi/2;
					end
				end
				if self.aimUp == false then
					tempBullet.faceLeft = self.faceLeft
				end
				
				addSprite(tempBullet.name, tempBullet)
				--tempBullet:update(dt)
				self.bulletInc = self.bulletInc + 1
				self.lastShot = 25;
				local shotCount = 0
				while shotCount < 3 do
					addParticle('gunSpawn',
									p1.x + self.gunSpawnX,
									p1.y + self.gunSpawnY,
									self.gunModX+(math.random()*8)-4,
									self.gunModY+(math.random()*8)-4,
									1,
									1,
									0,
									  function(part) 
										if(not part.init) then
											part.scaleX = .8+math.random()
											part.init = true
										end 
										part.xSpeed = part.xSpeed * .84 
										part.ySpeed = part.ySpeed * .84 
										part.scaleX = part.scaleX * .93
										if cWithLevel(part.x,part.y)  or part.scaleX < .1 or (math.abs(part.xSpeed)<.5 and  math.abs(part.ySpeed)<.5) then
											part.remove = true
										end 
									end)
                
                
                
              
					shotCount = shotCount + .3
				end
        shotCount = 0
				while shotCount < 3 do
          addParticle('muzzle',
									p1.x + self.gunSpawnX,
									p1.y + self.gunSpawnY-3,
										self.gunModX+(math.random()*8)-4,
									self.gunModY+(math.random()*8)-4,
									15,
									15,
									0,
									  function(part) 
										if(not part.init) then
											part.scaleX = 10
											part.init = true
										else 
										part.xSpeed = part.xSpeed * .4
										part.ySpeed = part.ySpeed * .4 
										part.scaleX = part.scaleX *.7
										if cWithLevel(part.x,part.y) or part.scaleX < .05 or math.abs(part.xSpeed)<.5 then
											part.remove = true
										end 
                    end
									end)
                	shotCount = shotCount + .6
         end
			end
			
         if input:released('puck') and not self.isRolling and self.puckControl == false then
			
            if self.puckOut then
               if singlePuck.stopped and singlePuck.canTP then
						self:recallPuck(true)
               end
            else 
               if self.faceLeft then
                  if self.aimUp then
                     self.gunModX, self.gunModY = transByRad(-12,0,0,0,0,0,self.rot+ (.5*math.pi))
                  else
                     self.gunModX, self.gunModY = transByRad(-12,0,0,0,0,0,self.rot)
                     end
                  
               else
                  if self.aimUp then
                     self.gunModX, self.gunModY = transByRad(12,0,0,0,0,0,self.rot- (.5*math.pi))
                  else
                     self.gunModX, self.gunModY = transByRad(12,0,0,0,0,0,self.rot)
                     end
               end
					self.lastShot = 25;
               self.puckOut = true
               singlePuck = puck:new()
               singlePuck.name = "sPuck"
               addSprite(singlePuck.name, singlePuck)
               singlePuck.x = p1.x + self.gunSpawnX - singlePuck.oX
               singlePuck.y = p1.y + self.gunSpawnY - singlePuck.oY
               singlePuck.xSpeed = self.gunModX
               singlePuck.ySpeed = self.gunModY
               
                for i=1,3,1 do 
               addParticle('muzzlePuck',
									p1.x + self.gunSpawnX,
									p1.y + self.gunSpawnY-3,
										self.gunModX+(math.random()*4)-2,
									self.gunModY+(math.random()*4)-2,
									15,
									15,
									0,
									  function(part) 
										if(not part.init) then
											part.scaleX = 10
											part.init = true
										else 
										part.xSpeed = part.xSpeed * .6
										part.ySpeed = part.ySpeed * .6 
										part.scaleX = part.scaleX *.8
										if cWithLevel(part.x,part.y) or part.scaleX < .05 or math.abs(part.xSpeed)<.1 then
											part.remove = true
										end 
									end
							end)
                end
            end
         end
 

         
         if input:down('puck') then
					self.puckHold = self.puckHold + 1
					if self.puckHold > 60 and self.puckOut then
						self:recallPuck(false)	
						self.puckControl = true;
					end
					
			else
					self.puckControl = false;
					self.puckHold = 0;
			end
		
		
      
         local change = angleDiff(self.tRot,self.rot)
         self.rot = self.rot + 0.2 * change
			if not self.isRolling then 
				if not self.inAir and self.running and self.touchingWall == false then
					if self.lastShot < 0 then
						if self.magnet then
							self.currentAni = "StompyWalk"
						else
							self.currentAni = "Run_001"
						end
						 
					else 
						if self.aimUp  then
							self.currentAni = "GunRunUp"
						else
							self.currentAni = "GunRun"
						end
						 
					end
				elseif self.inAir then
					 if self.lastShot < 0 then
						if self.wallStuck then
							if self.wallLookingBack then
								self.currentAni = "Walljump2"
							else
								self.currentAni = "Walljump1"
							end
						else 
							if self.ySpeed > 5 then
							 self.currentAni = "Jump"
							elseif self.ySpeed < -5 then
								self.currentAni = "Jump"
							else
								self.currentAni = "Jump"
							end
							
						
						end
					else
						if self.aimUp  then
							self.currentAni = "GunJumpUp"
						else
							self.currentAni = "GunJumpForward"
						end
					end
						self.spriterData:setTime(((math.clamp(-6,self.ySpeed,6) + 6)/10)/2);
				else
					if self.lastShot < 0 then
						 self.currentAni = "Stand"
					else 
						if self.aimUp  then
							self.currentAni = "GunUpStand"
						else
							self.currentAni = "GunStand"
						end
					end
				end
			else
				self.currentAni = "Roll"
				self.spriterData:setTime((self.rollingTime/25)*.64);
			end
			
			if self.spriterData:getCurrentAnimationName() ~= self.currentAni then
					if self.currentAni == "Jump" or self.currentAni == "GunJumpUp"  or self.currentAni == "GunJumpForward"  then
						self.spriterData:setCurrentAnimationName(self.currentAni,"once")	
					else
						self.spriterData:setCurrentAnimationName(self.currentAni)
					end
				
			
				
			end
			
		
		
		
         self:handleMapChanges(curMap.layers.mapChange.objects)
         self:handleHiddenAreas(curMap.layers.hiddenAreas.objects)
         if curMap.layers.magnetAreas ~= nil then
            self:handleMagnet(curMap.layers.magnetAreas.objects)
         end
			
			
			if curMap.layers.water ~= nil then
            self:handleWater(curMap.layers.water.objects)
         end
       --  self.anis.animations[self.currentAni]:resume()
         if self.rollingTime> 25 then
            self.isRolling= false
         else
            self.isRolling= true
         end
			self.spriterData:start()
      else
       	self.spriterData:stop()
         
      end
		
      self:handleCamera(curMap.layers.cam.objects)
      
		-- self.anis:setAnimation(self.currentAni)
      
  
     
      self.gunSpawnX, self.gunSpawnY = transByRad(self.gunX,self.gunY,0,0,0,0,self.rot)
      self.gunSpawnX =  self.gunSpawnX + self.oX
      self.gunSpawnY =  self.gunSpawnY + self.oY
		self.spriterData:setInverted( self.faceLeft )
     
  
		if self.lastShot>20 then
      for i=1,3,1 do 
			addParticle('smoke',
									p1.x + self.gunSpawnX+p1.xSpeed+((math.random()*5)-2.5),
									p1.y + self.gunSpawnY+p1.ySpeed+((math.random()*5)-2.5),
									0,
									0,
									1,
									1,
									0,
									  function(part)
                      if not part.init then
										part.red = 200
                    part.green =  20
                    part.blue = 200
                    part.alpha = 100*(self.lastShot/25)
                    part.init = true;
                    
                    end
                  
                end)
              
       end
      end
end


