--[[
--
--
--
--
--
--
--
--
--
]]
z = 1
io.stdout:setvbuf("no")
function math.clamp(low, n, high) return math.min(math.max(low, n), high) end
local loader = require("libs.loader")
anim8 = require("libs.anim8")
require("libs.secs")
require("sprite")
require("phys")
require("mapFunctions.mapUtil")
Spriter = require("libs/Spriter")
sti = require("libs.tiledLoader")
gamera = require 'libs.gamera'
Input = require 'libs.input'
tileSize = 32

camDelta = {0,0}
globalWindSpeed = 0
globMod = 0
globDir = 'left'
topLeftMap = {0,0}


gameState = 'menu'
local LightWorld = require "libs" 
     lightWorld = LightWorld({
     ambient = {255,255,255},
   -- refractionStrength = 32.0,
   -- reflectionVisibility = 0.75,
  })



--These two arrays will store all actual images and sounds within them. 
players = {}
mapSets = {}
mapNormal = {}
fadeEffects = {}
currentMaps = {}

changePause = false;



local sounds = {}


--this array stores all the sprites, graphical objects, in the game
spriteList = {}
cam = {}
camToX = 0
camToY = 0;

test1 = 0
windspeed = 0

    
    
    

local finishedLoading = false

function limitNum(tx,ty)
   if tx>ty then
      return ty
   end
   if tx<-ty then
      return -ty
   end
   return tx
end


   
function addSprite(n,l)
   spriteList[n] =l;
end
function deleteSprite(n)
   spriteList[n] = nil;
end
function newCam(tx,ty)
   cam = gamera.new(0,0,tx,ty)
end


function gameFinishedLoading() 

     if arg[#arg] == "-debug" then require("mobdebug").start() end   
   require("mattShaders")
   require("particles");
   require("mapFunctions.mapLoaders")
   require("player")
   require("puck")
   require("gLibs.screenFades")
   require("pBullet");
	require("mapFunctions.waterSim");
   
    faders = screenFades:new()
    
    
cam = gamera.new(0,0,1280,720)
   
   
  
  
   --faders:startFade();
 
   
  
   -- create light

   min_dt = 1/60
   next_time = love.timer.getTime()
   

   startGame()
   
    input = Input()
    require('loadInputs')
end


function math.rd(num)
    return math.floor(num+0.5)
end



----
---LOVE FUNCTIONS BELOW
----

--This function is called exactly once at the beginning of the game.
--@param(arg : unknown) A sequence strings which are command line arguments given to the game
function love.load(arg)
   
  
   
 
   



   --Load the loader which caches objects
   loader.newImage(  players, 'default', 'sprites/default.png')   
   --loader.newImage(  players, 'temp', 'sprites/tempPlay2.png')
   loader.newImage(  players, 'puck', 'sprites/puck.png')
   loader.newImage(  mapSets, 'collisionTiles', 'sprites/collisionTiles.png')
   loader.newImage(  mapSets, 'testTilesGrass', 'sprites/testTilesGrass.png')
   loader.newImage(  mapSets, '32Tiles', 'sprites/32Tiles.png')
   loader.newImage(  mapSets, 'yetAnotherTest', 'sprites/yetAnotherTest.png')
   loader.newImage(  mapSets, 'beachBackground', 'sprites/beachBackground.png')
	
	loader.newImage(  mapSets, 'forestBackground', 'sprites/forestBackground.png')
	loader.newImage(  mapSets, 'tiles_grass', 'sprites/tiles_grass.png')
	loader.newImage(  mapSets, 'vineTiles', 'sprites/vineTiles.png')
   loader.newImage( players, 'defaultBullet', 'sprites/defaultBullet.png')
   loader.newImage( players, 'afterimage', 'sprites/afterImage.png')
	
	
	loader.newImage( mapSets, 'redvine4', 'sprites/props/redvine4.png')
   -- 
   loader.start(
      function()
         finishedLoading = true
      end
   )



end

--Callback function used to draw on the screen every frame.
function love.draw()
  -- map.layers.CD.opacity = 0 ;  

     
      if finishedLoading == true then 
        
         
         cam:draw(function(l,t,w,h)
             --  lightWorld:draw(function()
                  love.graphics.setColor(111, 111, 111)
                  
                  if gameState == 'game' then
                     love.graphics.rectangle("fill", -l/1, -t/1, love.graphics.getWidth()*50, love.graphics.getHeight()*50)
                  
                     --curMap:setDrawRange(x, y, 20000 , 7200)
							
                     curMap:draw(nil,nil,false)
							
							for p = -10, 10, 1 do
								for nam, spr in pairs(spriteList) do
									if spr.depth == p then
										if spr.hasAni == 'Spriter' then 
											local bx, by = 0,0
											if(spr.faceLeft) then
												bx, by = transByRad(-spr.rotOffX+spr.invOff ,-spr.rotOffY,0,0,spr.rotOffX+spr.invOff,spr.rotOffY,spr.rot)
												spr.spriterData:draw(spr.x+bx-spr.invOff,spr.y+by,spr.rot);	
											else
												bx, by = transByRad(-spr.rotOffX ,-spr.rotOffY,0,0,spr.rotOffX,spr.rotOffY,spr.rot)
												spr.spriterData:draw(spr.x+bx,spr.y+by,spr.rot);	
											end
								
											
											
											
											
											
										elseif spr.hasAni then
											spr.anis.animation.flippedH = spr.faceLeft
											spr.anis.x = spr.x
											spr.anis.y = spr.y
											spr.anis.ix, spr.anis.iy = transByRad(spr.oX,spr.oY,0,0,-spr.oX,-spr.oY,spr.rot)
											spr.anis:drawAnimation(spr.rot)
											if spr.hasAni2 then
												spr.anis2.animation.flippedH = spr.faceLeft
												spr.anis2.x = spr.x+spr.oX2
												spr.anis2.y = spr.y+spr.oY2
												spr.anis2.ix, spr.anis2.iy = transByRad(spr.oX2,spr.oY2,0,0,-spr.oX2,-spr.oY2,spr.rot)
												spr.anis2:drawAnimation(spr.rot)
											end
										else
											spr:draw();
										end
									end
								end
                     end
                     curMap:draw(nil,nil,true)
							drawParticles()
                  end
                  faders:draw();
				
          --  end)
         end)
 
    local cur_time = love.timer.getTime()
            if next_time <= cur_time then 
            next_time = cur_time
            return
         end
     love.timer.sleep(next_time - cur_time)
   end
   
end

--Callback function used to update the state of the game every frame.
--@param(dt : number) The duration of the previous frame
function love.update(dt)
    local oldCam = {cam.x,cam.y}
   love.window.setTitle("A game FPS: ".. love.timer.getFPS())
   if not finishedLoading then
      loader.update() -- You must do this on each iteration until all resources are loaded
      if finishedLoading then 
         gameFinishedLoading()
      end
   else 
      next_time = next_time + min_dt
      
      
      windspeed = windspeed - 4 + (math.random()*7)
      if windspeed > 99 then
          windspeed = 99
        end
      if windspeed < 0 then
          windspeed = 0
        end
      
   

      for nam, spr in pairs(spriteList) do
       	if spr.hasAni == 'Spriter' then 
				elseif spr.hasAni  then
				spr.anis:update(1/60);
				if spr.hasAni2 then
						spr.anis2:update(1/60);
					end
         else

         end
         spr:update(dt)
      end
      
      
      if gameState == 'game' then
			particleUpdate()
         curMap:update(dt)
         handleParallax()
         cam:setPosition(math.floor(camToX),math.floor(camToY))
      end
      faders:update(dt)
      
 input:update(dt)
   if input:down("fade") then
    --  faders:startFade()
	cam:setScale(.09) 
   end
     camDelta = {oldCam[1]-cam.x, oldCam[2]-cam.y}
   end
   
  
end

--Callback function triggered when window receives or loses focus
--@param(f : boolean) window focus
function love.focus(f)
  
end

--Called when a joystick button is pressed
--@param(joystick : Joystick) The joystick number
--@param(button : number) The button number
function love.joystickpressed(joystick,button)
   if finishedLoading == true then 
      input:gamepadpressed(joystick, button)
   end
end

--Called when a joystick button is released
--@param(joystick : Joystick) The joystick
--@param(button : number) The button number
function love.joystickreleased(joystick,button)
   if finishedLoading == true then 
      input:gamepadreleased(joystick, button)
   end
end

function love.joystickaxis(joystick, axis, value )
   if finishedLoading == true then 
      input:gamepadaxis(joystick, axis, value)
   end
end
--Callback function triggered when a key is pressed.
--@param(key : string) Character of the key pressed (KeyConstant enumeration)
--@param(isrepeat : boolean) Whether this keypress event is a repeat. 
function love.keypressed(key,isrepeat)
   if finishedLoading == true then 
      input:keypressed(key)
   end
end

--Callback function triggered when a key is released.
--@param(key : string) Character of the key released (KeyConstant enumeration)
function love.keyreleased(key)
   if finishedLoading == true then 
      input:keyreleased(key)
   end
end

--Callback function triggered when a mouse button is pressed.
--@param(x : number) Mouse x position.
--@param(y : number) Mouse y position.
--@param(button : string) Mouse button pressed (MouseConstant enumeration).
function love.mousepressed(x,y,button)
    if finishedLoading == true then 
   input:mousepressed(button)
   end
   if button == "wu" then
    z = z + 1

	elseif button == "wd" then
    z = z - 1

	end
	

end

--Callback function triggered when a mouse button is released.
--@param(x : number) Mouse x position.
--@param(y : number) Mouse y position.
--@param(button : string) Mouse button released (MouseConstant enumeration).
function love.mousereleased(x,y,button)
  
      
     -- print(tostring(cWithLevel(x, y))..","..getCTile(x, y))
      if finishedLoading == true then 
			x, y = cam:toWorld(x,y)
         input:mousereleased(button)
			print(x,y)
			for i = 10, 1, -1 do
			addParticle('boid',
											x+(math.random()*120),
											y+(math.random()*120),
											0,
											0,
											0,
											0,
											0,
											function(part) 
												local temp1 = {0,0}
												local temp2 = {0,0}
												local temp3 = {0,0}
												local count = 0
												for nam2, p2 in pairs(particleList) do
													if p2.name == 'boid' then
														if p2.x ~= part.x and p2.y ~= part.y then
															count = count + 1
															temp1[1] =  temp1[1] + p2.x
															temp1[2] =  temp1[2] + p2.y
															 temp3[1] =  temp3[1] + p2.xSpeed
															 temp3[2] =  temp3[2] + p2.ySpeed
													
															if math.abs(p2.x - part.x)<5 and math.abs(p2.y - part.y)<5 then
																temp2[1] = temp2[1] -(part.x - p2.x)
																temp2[2] = temp2[2 ]-( part.y - p2.y)
															end
														end
													end
												end
												temp1[1] = temp1[1]/count
												temp1[2] = temp1[2]/count
												temp3[1] = temp3[1]/80/count
												temp3[2] = temp3[2]/80/count
										
										
												temp1[1] =(temp1[1]-part.x)/800
												temp1[2] =(temp1[2]-part.y)/800
												local t = 0 
												
												
						
												
												part.xSpeed = part.xSpeed+(temp1[1]+temp2[1]+temp3[1])
												part.ySpeed = part.ySpeed+(temp1[2]+temp2[2]+temp3[2])
												if part.xSpeed >5 then
													part.xSpeed = 5
												end
												if part.ySpeed >5 then
													part.ySpeed = 5 
												end
												if part.xSpeed <-5 then
													part.xSpeed = -5
												end
												if part.ySpeed <-5 then
													part.ySpeed = -5 
												end
											
												if(not part.init) then
													part.wind = 0								
												end
											end
										)
										end
      end
end

--Callback function triggered when window receives or loses mouse focus.
--@param(f : boolean) True when the window receives mouse focus, false when it loses it.
function love.mousefocus(f)
  
end

--Callback function triggered when window is minimized/hidden or unminimized by the user.
--@param(v : boolean) true if the window is visible, false otherwise
function love.visible(v)
  
end


--Callback function triggered when the game is closed.
--@ret(boolean) Whether to abort quitting--if true, do not close the game.
function love.quit()
  return false
end


