particleList = {}
local firstCanvas;
local secondCanvas;
local currentCanvas
local otherCanvas
  firstCanvas = love.graphics.newCanvas()
  secondCanvas = love.graphics.newCanvas()
  currentCanvas = firstCanvas
	 otherCanvas = secondCanvas

particleTypes = {}

local updateParticles = false

local grassCanvas = nil
local grassCanvasPos = {0,0}
--pass a function using p
function addParticle(tName,tx,ty,txS,tyS,tscaleX,tscaleY,tRot,modFunction)
	table.insert(particleList, {
			name = tName, 
			x = tx, 
			y = ty,
			xSpeed = txS,
			ySpeed = tyS,
			rot = tRot,
			scaleX = 1,
			scaleY = 1,
			mFunc = modFunction})
	
end

boidMassCenter = {0,0,0,0}
function particleUpdate()
   if not changePause then
  local p, i = cam:toScreen(p1.x,p1.y)
  	
	updateParticles =  true
	--globalWindSpeed = globalWindSpeed + (math.random()/2)-.25 
	local boidAllPos = {0,0,0,0}
	local boidCount  = 0
	if updateParticles then
		for nam2, p in pairs(particleList) do
			if p.name == 'boid'  then
				boidCount = boidCount+1
				boidAllPos[1] = boidAllPos[1] + p.x
				boidAllPos[2] = boidAllPos[2] + p.y
				boidAllPos[3] = boidAllPos[3] + p.xSpeed
				boidAllPos[4] = boidAllPos[4] + p.ySpeed
			end
		end
		boidMassCenter[1] = boidAllPos[1]/boidCount
		boidMassCenter[2] = boidAllPos[2]/boidCount
		boidMassCenter[3] = boidAllPos[3]/boidCount
		boidMassCenter[4] = boidAllPos[4]/boidCount

		for nam, p in pairs(particleList) do
			p.x = p.x + p.xSpeed
			p.y = p.y + p.ySpeed
			p.xSpeed = p.xSpeed
			p.ySpeed = p.ySpeed 
			
			p:mFunc(p)
			if p.remove then
				particleList[nam] = nil;
			end
	
		end
	end
  end
end

function drawParticles()
	local l = 0 
	for nam, p in pairs(particleList) do
	 l = l + 1
		if p.name == 'waterDrop' then			
			love.graphics.push( )
			love.graphics.translate(p.x, p.y)
      if not p.stenc then
        
p.stenc=        function()
          
          love.graphics.rotate(   math.atan2(p.ySpeed,p.xSpeed)    +    (math.pi/2)      )
          love.graphics.circle('fill', 0, 0, 1.5 * p.scaleX, 10 )
          if(p.drop > .5) then
          love.graphics.polygon('fill', 1.5 * p.scaleX, 0, 0, 6 * p.scaleX, -1.5 * p.scaleX, 0)
          
          end
        end
      end
			
			
		--	love.graphics.setStencil(p.stenc)
			love.graphics.setColor( 0, 128, 200, 100)
			
			p.stenc();
			love.graphics.pop()
			
		end
		if p.name == 'gunSpawn' then
			love.graphics.setColor( 254, 178, 46, 255)
			love.graphics.circle('fill', p.x, p.y,  p.scaleX, 10 )
			love.graphics.setColor( 255, 255, 255, 255 )
		end
    if p.name == 'muzzle' then
			love.graphics.setColor( 254, 178, 46, 255)
			love.graphics.rectangle('line', p.x, p.y,  p.scaleX, p.scaleX,10 )
			love.graphics.setColor( 255, 255, 255, 255 )
		end
    if p.name == 'muzzlePuck' then
			love.graphics.setColor( 100, 178, 255, 255)
			love.graphics.circle('line', p.x, p.y,  p.scaleX, 10 )
			love.graphics.setColor( 255, 255, 255, 255 )
		end
		if p.name == 'greenGrass' then

			if p.init and p.drawn == false then
				
				if grassCanvas == nil then
					for nam, obj in pairs(curMap.layers.camBound.objects) do
						grassCanvas = love.graphics.newCanvas( obj.width, obj.height )
					print(obj.x, obj.y )
						grassCanvasPos = {obj.x, obj.y}
						love.graphics.setCanvas(grassCanvas )
						love.graphics.circle('fill',0,0,5000,5) 
						love.graphics.setCanvas( )
					end 
				end
					love.graphics.push()
				love.graphics.setCanvas(grassCanvas )
			
				
		
				love.graphics.setLineWidth( 2 )

				local pp = -2
				local bez = 's'
		
				love.graphics.setColor( 29, 69+(p.initWind*4), 23, 255)
				
				for  i in ipairs(p.e) do
					if i % 2 == 0 then
					 p.e[i] = p.e[i] - grassCanvasPos[2]
					
					else
					 p.e[i] = p.e[i] - grassCanvasPos[1]
					
					end
					
				end
				love.graphics.polygon('fill', p.e)
			
			
				love.graphics.setColor( 255, 255, 255, 255 )

				love.graphics.setCanvas()
				love.graphics.pop()
		
				p.drawn = true
			end	
			love.graphics.setCanvas(grassCanvas )
			
			--	love.graphics.point(p1.x,p1.y)
			
			love.graphics.setCanvas()
			
		end
		if p.name == 'greenVine' then
			if p.init then
				love.graphics.push( )
				love.graphics.setColor( 160, 19, 23, 255)
					love.graphics.setColor( 29, 69+(p.rando*15), 23, 255)
love.graphics.setLineWidth( 1 )
				love.graphics.line(p.e)

				love.graphics.setLineWidth( .5 )
				for nam, leaf in pairs(p.leaves) do
					love.graphics.push( )
					love.graphics.translate(leaf[1],leaf[2])
					love.graphics.rotate(leaf[4])
					love.graphics.circle('fill',0,4,1+leaf[3],6)
					love.graphics.circle('fill',0,7,leaf[3],6)
					love.graphics.line(0,0,0,7)
				
						love.graphics.pop()
						
				end
				
				for nam, leaf in pairs(p.droop) do
					love.graphics.push( )
					love.graphics.setLineWidth( .5 )
					love.graphics.line(leaf[1],leaf[2],leaf[1],leaf[3]+leaf[2])
				
						love.graphics.pop()
				end
				for nam, leaf in pairs(p.ropes) do
					love.graphics.push( )
					
					--love.graphics.circle('fill',leaf[1],leaf[2],1+math.sin(leaf[3]*100)*2 ,5)
					leaf[3] = leaf[3] + .0015
					love.graphics.pop()
				end
				love.graphics.setColor( 255, 255, 255, 255 )


				love.graphics.pop()
			end
		end
		if p.name == 'boid' then
			love.graphics.setColor( 255, 255, 255, 255 )
			love.graphics.circle('fill', p.x,p.y, 2)
		end
	end
  
  --DRAW SMOKE PARTICLES
love.graphics.push();  
   love.graphics.setColor(255,255,255,255) 
		love.graphics.setShader();
			love.graphics.setCanvas()
love.graphics.scale( 1, 1 )
 if grassCanvas ~= nil then
	love.graphics.draw(grassCanvas,grassCanvasPos[1],grassCanvasPos[2])
  end

love.graphics.pop();  

  love.graphics.setCanvas(firstCanvas)
   love.graphics.setColor(200,200,150,100)
	
  for nam, p in pairs(particleList) do
    if p.name == 'smoke' then
      
     
      love.graphics.circle("fill",p.x,p.y,6);
      p.remove = true
    end
  end

  

  love.graphics.setCanvas(otherCanvas)
	love.graphics.setShader(smokeShader);
	love.graphics.draw(currentCanvas,cam.x-((cam.scale*1280)/2),cam.y-((cam.scale*720)/2))
	love.graphics.setShader();
	love.graphics.setCanvas()

	
	currentCanvas:clear()

	love.graphics.setCanvas(currentCanvas)
	love.graphics.setShader(smokeShader);
	love.graphics.draw(otherCanvas,cam.x-((cam.scale*1280)/2)+camDelta[1]+(windspeed/80),cam.y-((cam.scale*720)/2)+camDelta[2])
	love.graphics.setShader();
	love.graphics.setCanvas()

		love.graphics.draw(currentCanvas,cam.x-((cam.scale*1280)/2),cam.y-((cam.scale*720)/2))
  
    love.graphics.setColor(255,255,255,255)
	otherCanvas:clear()

--  print(grassCanvas,grassCanvasPos[1],grassCanvasPos[2])
end

function newParticle()
	
	
end
