--
--
--
puck = sprite:new()
--This class is the base class for all graphical objects.
--
--
puck.graphic = players.puck
puck.graphic2 = players.afterimage
puck.xSpeed = 0;
puck.ySpeed = 0;

puck.oX = 8
puck.oY = 8     
puck.oX2 = -5
puck.oY2 = -100 
puck.stopped = false

puck.anis = lightWorld:newAnimationGrid(puck.graphic,100,100)
puck.anis2 = lightWorld:newAnimationGrid(puck.graphic2,100,100)
--player.anis:setNormalMap(players.tempNormal)
puck.g = puck.anis:newGrid(37, 10)




puck.anis:addAnimation('all',puck.g(1,'1-9'), 0.0167)
puck.hasAni = true
puck.currentAni = "all"
puck.anis:setAnimation(puck.currentAni)
puck.anis.ix = 0
puck.stopTime = 0;
puck.anis.iy = 0
puck.canTP = false;




puck.g2 = puck.anis2:newGrid(38, 106)
puck.anis2:addAnimation('all',puck.g2(1,1), 0.0167)
puck.anis2:setAnimation('all')
puck.hasAni2 = false;




function puck:update(dt)

       local oldX = self.x;
      self.x = math.rd(self.x + math.rd(self.xSpeed))
      self.y = math.rd(self.y + math.rd(self.ySpeed))
     
      self.ySpeed = self.ySpeed + .3
      self.xSpeed = self.xSpeed * .98
      if self.ySpeed > 12 then
            self.ySpeed = 12
      end
      if self.xSpeed > 12 then
            self.xSpeed = 12
      end
      if self.xSpeed < -12 then
            self.xSpeed = -12
      end
      
     if math.abs(self.xSpeed) <.3 then
         self.xSpeed = 0
      end
      if math.abs(self.ySpeed) <.3 then
         self.ySpeed = 0
      end
     
      while cWithLevel(self.x+self.oX, self.y+self.oY) do 
         self.y = self.y - 1
      end
   
 
      if cWithLevel(self.x+self.oX, self.y+self.oY+2) then
         if self.ySpeed>3 then
            self.y = self.y - 4
            self.ySpeed = self.ySpeed * -.5
            self.xSpeed = self.xSpeed * .9
         else
            self.ySpeed = 0
         end
      end   
      
      
      while cWithLevel(self.x+self.oX, self.y) do 
         self.y = self.y + 1
      end
   
 
      if cWithLevel(self.x+self.oX, self.y-2) then
            self.y = self.y + 4
            self.ySpeed = self.ySpeed * -.8
      end   
      
      
      while cWithLevel(self.x, self.y+(self.oY/2)) do 
         self.x = self.x + 1
      end
      while cWithLevel(self.x+(self.oX*2), self.y+(self.oY/2)) do 
         self.x = self.x - 1
      end
      if cWithLevel(self.x-2, self.y+(self.oY/2)) then
         self.x = self.x  + 4
         self.xSpeed = self.xSpeed * -.6        
      end   
      
      if cWithLevel(self.x+2+(self.oX*2), self.y+(self.oY/2)) then
         self.x = self.x  - 4
         self.xSpeed = self.xSpeed * -.6        
      end   
     -- self.rot = self.rot+((oldX - self.x)/12)
      
      self.anis:pause()
      if self.ySpeed == 0 and self.xSpeed == 0 then
         self.stopTime = self.stopTime + 1
         if self.stopTime>10 then
            self.stopped = true
				if self.stopTime<= 13 then
		
					
					if not cWithLevel(self.x+self.oX,self.y+self.oY) 
					and not cWithLevel(self.x+self.oX,self.y+self.oY-20)
					and not cWithLevel(self.x+self.oX,self.y+self.oY-40)
					and not cWithLevel(self.x+self.oX,self.y+self.oY-60)
					and not cWithLevel(self.x+self.oX,self.y+self.oY-80)
					and not cWithLevel(self.x+self.oX,self.y+self.oY-100) then
					
							self.anis:gotoFrame(((self.stopTime-10)*3))
							self.canTP = true
							self.hasAni2 = true
					else
						self.anis:gotoFrame(((self.stopTime-10)*3)-1)
						self.canTP = false
					end
				end
         end
         
      else
			self.anis:gotoFrame(1)
		end
      self.anis:setAnimation(self.currentAni)
      
end